SystemOrganization addCategory: #'SourceCity-Core'!

Object subclass: #AbstractCityComponent
	instanceVariableNames: 'model id width height color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!AbstractCityComponent commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color
	^ color! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color: anObject
	color := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 11:20'!
height
	^ height! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 11:20'!
height: anObject
	height := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:14'!
id
	^ id! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:14'!
id: anObject
	id := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 11:23'!
initialize
	id := 0.
	width:= 0.5.
	height:= 0.! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:14'!
model
	^ model! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:14'!
model: anObject
	model := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 09:30'!
width
	^ width! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 09:30'!
width: anObject
	width := anObject! !

AbstractCityComponent subclass: #Building
	instanceVariableNames: 'district position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!Building commentStamp: '<historical>' prior: 0!
A Building is the level abstraction.!

!Building class methodsFor: 'instance creation' stamp: 'DouailleErwan 7/2/2012 11:20'!
forModel: aModel inDistrict: aDistrict id: anId height: height width: width color: aColor

	^ self new 
		model: aModel;
		id: anId;
		width: width;
		height: height;
		district: aDistrict;
		color: aColor.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
district
	^ district! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 14:55'!
district: anObject
	district := anObject.
	self district add: self.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 11:20'!
height
	(height < 0.5)
	ifTrue: [^ 0.5].
	^ height.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 09:40'!
position
	^ position! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 09:40'!
position: anObject
	position := anObject! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:27'!
printOn: aStream

	district ifNotNil: [ aStream
					nextPutAll: district asString; 
					nextPutAll: ' -> '].
	model ifNotNil: [ aStream 
					nextPutAll: ' Buidling: '; 
					nextPutAll: model name].! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 11:21'!
width
	(super width < 0.5)
	ifTrue: [^ 0.5].
	^ super width.! !

AbstractCityComponent subclass: #City
	instanceVariableNames: 'districts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!City commentStamp: '<historical>' prior: 0!
A City represents the largest model element. It contains a list of districts.!

!City class methodsFor: 'instance creation' stamp: 'DouailleErwan 6/15/2012 12:38'!
model: aName
	^ self new 
		model: aName.
		! !

!City methodsFor: 'adding' stamp: 'DouailleErwan 6/18/2012 10:23'!
add: aDistrict

	districts add: aDistrict.
	self width: ( self districts inject: 0 into: [ :sum :each | sum + each width.]).
	^ aDistrict! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color
	^ Color r: 0.6 g: 0.6 b: 0.6! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:15'!
districts
	^ districts! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:15'!
districts: anObject
	districts := anObject! !

!City methodsFor: 'comparing' stamp: 'DouailleErwan 6/12/2012 10:22'!
hasDistrictNamed: aString

	^ districts anySatisfy: [ :each | each model name = aString ]! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 16:47'!
height
	"static height for city"
	^ 2! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:22'!
initialize

	super initialize.
	districts := OrderedCollection new.! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/15/2012 12:37'!
printOn: aStream

	model ifNotNil: [ aStream 
					nextPutAll: ' City: '; 
					nextPutAll: self model].! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 15:18'!
width: anObject
	"re calculate the width of the city, better way was found to have a nice looking"
	width := anObject sqrt roundedUp *30! !

AbstractCityComponent subclass: #District
	instanceVariableNames: 'buildings city position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!District commentStamp: '<historical>' prior: 0!
A District is a secondary city abstractions!

!District class methodsFor: 'instance creation' stamp: 'DouailleErwan 6/18/2012 10:11'!
forPackage: aPackage inCity: aCity id: aValue

	^ self new
		model: aPackage;
		id: aValue;
		city: aCity.! !

!District methodsFor: 'adding' stamp: 'DouailleErwan 6/18/2012 10:19'!
add: aBuilding

	buildings add: aBuilding.
	self width: ( self buildings inject: 0 into: [ :sum :each | sum + each width.]).
	^ aBuilding.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
buildings
	^ buildings! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
buildings: anObject
	buildings := anObject! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
city
	^ city! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 14:54'!
city: anObject
	city := anObject.
	self city add: self.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:30'!
color
	^Color r: 0.8 g: 0.8 b:0.8! !

!District methodsFor: 'comparing' stamp: 'DouailleErwan 6/15/2012 12:38'!
hasBuildingNamed: aString

	^ buildings anySatisfy: [ :each | each model name = aString ]! !

!District methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/26/2012 16:47'!
height
	"same than city height"
	^1! !

!District methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/12/2012 14:52'!
initialize 
	
	super initialize.
	buildings := OrderedCollection new.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 09:40'!
position
	^ position! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 09:40'!
position: anObject
	position := anObject! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:25'!
printOn: aStream

	city ifNotNil: [ aStream
					nextPutAll: city asString;
					nextPutAll: '-> '].
	model ifNotNil: [ aStream 
					nextPutAll: ' District: '; 
					nextPutAll: model name ].! !

!District methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/18/2012 10:19'!
width: anObject
	"re calculate the width of the district, better way was found to have a nice looking"
	width := anObject sqrt asFloat roundedUp*2 ! !

Object subclass: #SourceCityApi
	instanceVariableNames: 'sourceCityImporter cameraXposition cameraYposition cameraZposition backgroundOpenGL buildingGap districtGap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!SourceCityApi commentStamp: '<historical>' prior: 0!
Provides default configuration parameters for Source city GL views. All the default methods provide extension poinits for customizing GL views. If someone wants to describe their own config, default methods can be overriden.!

!SourceCityApi class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/2/2012 14:16'!
default
	^ self new! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:20'!
backgroundOpenGL
	^ backgroundOpenGL! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:20'!
backgroundOpenGL: anObject
	backgroundOpenGL := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:22'!
buildingGap
	^ buildingGap! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:22'!
buildingGap: anObject
	buildingGap := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraXposition
	^ cameraXposition! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraXposition: anObject
	cameraXposition := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraYposition
	^ cameraYposition! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraYposition: anObject
	cameraYposition := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraZposition
	^ cameraZposition! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:05'!
cameraZposition: anObject
	cameraZposition := anObject! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:23'!
districtGap
	^ districtGap! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:23'!
districtGap: anObject
	districtGap := anObject! !

!SourceCityApi methodsFor: 'initialize-release' stamp: 'DouailleErwan 7/2/2012 14:23'!
initialize
	cameraXposition := -196.
	cameraYposition := -15.
	cameraZposition := 0.
	sourceCityImporter :=  #().
	backgroundOpenGL := Color white.
	buildingGap := 2.
	districtGap := 2.! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:07'!
sourceCityImporter
	^ sourceCityImporter! !

!SourceCityApi methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:07'!
sourceCityImporter: anObject
	sourceCityImporter := anObject! !

!Float methodsFor: '*SourceCity-Core' stamp: 'douaille 4/10/2012 14:35'!
roundedUp
	"Return a rounded up"
	self fractionPart abs = 0.0
	ifTrue: [
		^self truncated
		]
	ifFalse: [
		^self truncated + self sign rounded
		]! !
